#ifndef SHOWPLAYER_H
#define SHOWPLAYER_H

#include <vector>
#include <string>

#include <QDialog>
#include <QFileDialog>

#include "defines.h"
#include "cuetrackwidget.h"
#include "cuetracklistwidget.h"
#include "trackdialog.h"
#include "settings.h"
#include "ui_showplayer.h"

namespace Ui {
    class ShowPlayer;
}

class ShowPlayer : public QDialog
{
    Q_OBJECT

public:
    explicit ShowPlayer(QWidget *parent = nullptr);
    ~ShowPlayer();

private:
    Ui::ShowPlayer *ui;
    Status currentStatus = Status::Iddle;
    size_t filesLoaded = 0;
    int layersUsed[MAX_LAYERS];

    void updateTrackStateInEngine(CueTrackWidget *track);

private slots:
    void onAddTrack();
    void go();

signals:
    void uiPlaybackChanged(int layer, Status s);
    void uiSliderChanged(int layer, Slider s, int vol);
    void uiLoadMedia(int layer, QString s);
};

#endif // SHOWPLAYER_H
